/*
** Tetris.h for XmtdsTetris widget in .
** 
** Made by MaxTheDogSays (dubray_f@epita.fr && rancur_v@epita.fr
** Login   <vr@epita.fr>
** 
** Started on  Mon May 16 22:17:04 1994 vr
** Last update Wed Sep 14 15:48:44 1994 hydrix
*/

#ifndef _XMTDSTETRIS_H_
#define _XMTDSTETRIS_H_	1

#include <X11/StringDefs.h>

void	XmtdsTetrisStart(/*w*/);
void	XmtdsTetrisDrawShape(/*w,x,y,shape*/);
void	XmtdsTetrisClear(/*w*/);
void	XmtdsTetrisSet(/*w,x,y*/);
void	XmtdsTetrisInsertLine(/*w*/);
void	XmtdsTetrisSetShape(/*w,shape*/);
void	XmtdsTetrisGoDown(/*w*/);

typedef struct
{
   int	reason;
   int	detail;
} xmtdsscoreCallbackStruct;

#define SCORE_NORMAL		0
#define SCORE_LINE		1
#define SCORE_END		2

#define PROTO_MOVE_LEFT		0
#define PROTO_MOVE_RIGHT	1
#define PROTO_MOVE_DOWN		2
#define PROTO_ROTATE_LEFT	3
#define PROTO_ROTATE_RIGHT	4
#define PROTO_DROP		5
#define PROTO_PAUSE		6
#define PROTO_INSERT_LINE	7
#define PROTO_START		8
#define PROTO_LOST		9
#define PROTO_GO_DOWN		10
#define PROTO_TIMER		11
#define PROTO_SHAPE		128

#define XtNinterval		"interval"

#define XtNblockWidth		"blockWidth"
#define XtCBlockWidth		"BlockWidth"

#define XtNblockHeight		"blockHeight"
#define XtCBlockHeight		"BlockHeight"

#define XtNgameWidth		"gameWidth"
#define XtCGameWidth		"GameWidth"

#define XtNgameHeight		"gameHeight"
#define XtCGameHeight		"GameHeight"

#define XtNcolorList		"colorList"
#define XtCColorList		"ColorList"

#define XtNscoreCallback	"scoreCallback"

#define XtNcomm			"comm"
#define XtCComm			"Comm"

#define XtNfd			"fd"
#define XtCFd			"Fd"

#define XtNuserData		"userData"
#define XtCUserData		"UserData"

#define XtNslave		"slave"
#define XtCSlave		"Slave"

extern WidgetClass		xmtdsTetrisWidgetClass;

typedef struct _XmtdsTetrisClassRec	*XmtdsTetrisWidgetClass;
typedef struct _XmtdsTetrisRec		*XmtdsTetrisWidget;

#endif /* _XMTDSTETRIS_H_ */
